package ch.uzh.csg.filesharing;
import java.io.Serializable;

import ch.uzh.csg.tomp2p.routing.NodeAddress;

public class Check implements Serializable
{
	final private int amount;
	final private NodeAddress intermediate;
	final private NodeAddress target;

	public Check(NodeAddress intermediate, NodeAddress target, int amount)
	{
		this.amount = amount;
		this.intermediate = intermediate;
		this.target = target;
	}

	public NodeAddress getIntermediate()
	{
		return intermediate;
	}

	public NodeAddress getTarget()
	{
		return target;
	}

	public int getAmount()
	{
		return amount;
	}

	@Override
	public String toString()
	{
		StringBuilder sb = new StringBuilder("Check: Intermed. ");
		sb.append(intermediate.getID());
		sb.append(" <=> Tgt. ");
		sb.append(target.getID());
		return sb.toString();
	}
}
