package ch.uzh.csg.filesharing.fileutils;
import java.io.File;
import java.io.IOException;
import java.util.List;

public class MergerThreadLink extends MergerThread
{
	final private File fileNameTmp;
	final private File fileNameOrig;
	final private static Object lock = new Object();

	public MergerThreadLink(List<File> splits, File tmpFolder, File fileName, long fileLength,
			long splitSize, boolean deleteSegments, boolean digest)
	{
		super(splits, tmpFolder, fileLength, splitSize, deleteSegments, digest);
		this.fileNameTmp = tmpFolder;
		this.fileNameOrig = fileName;
	}

	@Override
	public void mergeFile() throws IOException
	{
		synchronized (lock)
		{
			super.mergeFile();
			FileUtils.createSoftLink(fileNameTmp, fileNameOrig);
		}
	}
}
