package ch.uzh.csg.filesharing.fileutils;
import java.util.BitSet;
import java.util.Random;

public class RandomBitSet extends BitSet
{
	final private static Random rnd = new Random();

	public RandomBitSet(BitSet data)
	{
		or(data);
	}

	public int getRandomChunkNr()
	{
		synchronized (this)
		{
			int next = rnd.nextInt(size());
			int index = nextSetBit(next);
			if (index >= 0)
			{
				clear(index);
				return index;
			}
			else
			{
				for (int i = next; i >= 0; i--)
				{
					if (get(i))
					{
						clear(i);
						return i;
					}
				}
			}
		}
		return -1;
	}

	public boolean noMoreChunks()
	{
		synchronized (this)
		{
			return cardinality() == 0;
		}
	}
}
