package ch.uzh.csg.filesharing.fileutils;
import java.io.File;
import java.io.IOException;
import java.util.ArrayList;
import java.util.List;
import java.util.Observable;
import java.util.Observer;

public class SplitterThreadLink extends SplitterThread implements Observer
{
	final private File linkDest;
	final private static Object lock = new Object();
	final private List<File> target = new ArrayList<File>();
	final private List<File> link = new ArrayList<File>();

	public SplitterThreadLink(File sourceFile, File destinationFolder, File tmpFolder,
			long splitSize)
	{
		this(sourceFile, destinationFolder, tmpFolder, splitSize, false);
	}

	public SplitterThreadLink(File sourceFile, File destinationFolder, File tmpFolder,
			long splitSize, boolean digest)
	{
		super(sourceFile, tmpFolder, splitSize, digest);
		linkDest = destinationFolder;
		addObserver(this);
	}

	public void splitFile() throws IOException
	{
		synchronized (lock)
		{
			super.splitFile();
		}
	}

	@Override
	public void update(Observable o, Object arg)
	{
		synchronized (lock)
		{
			if (arg != null)
			{
				File t = (File) arg;
				File l = new File(linkDest, ((File) arg).getName());
				target.add(t);
				link.add(l);
			}
			else
			{
				try
				{
					FileUtils.createSoftLink(target, link);
				}
				catch (IOException e)
				{
					e.printStackTrace();
				}
			}
		}
	}
}
