package ch.uzh.csg.filesharing.future;
import ch.uzh.csg.tomp2p.common.BaseFutureImpl;
import ch.uzh.csg.tomp2p.message.Message;

public class FuturePublishImpl extends BaseFutureImpl implements FuturePublish
{
	private Boolean namePublished;
	private Boolean trackerPublished;

	@Override
	public void setNamePublished(boolean name)
	{
		synchronized (lock)
		{
			this.namePublished = Boolean.valueOf(name);
			if (trackerPublished == null || !setCompletedAndNotify())
				return;
			
			type = !(namePublished && trackerPublished) ? Message.TYPE_NOT_OK : Message.TYPE_OK;
			
			
		}
		notifyListerenrs();
	}

	@Override
	public Boolean getNamePublished()
	{
		synchronized (lock)
		{
			return namePublished;
		}
	}

	@Override
	public void setTrackerPublished(boolean tracker)
	{
		synchronized (lock)
		{
			this.trackerPublished = Boolean.valueOf(tracker);
			if (namePublished == null || !setCompletedAndNotify())
				return;
			type = !(namePublished && trackerPublished) ? Message.TYPE_NOT_OK : Message.TYPE_OK;
		}
		notifyListerenrs();
	}

	@Override
	public Boolean getTrackerPublished()
	{
		synchronized (lock)
		{
			return trackerPublished;
		}
	}
}
