package ch.uzh.csg.filesharing;
import java.io.File;
import java.net.URISyntaxException;
import java.util.Observable;
import java.util.Observer;

import org.junit.Assert;
import org.junit.Test;

import ch.uzh.csg.filesharing.fileutils.MergerThread;
import ch.uzh.csg.filesharing.fileutils.SplitterThread;
import ch.uzh.csg.tomp2p.Utils;

public class TestSplitterJoiner
{
	@Test
	public void testSplitJoin() throws InterruptedException, URISyntaxException
	{
		final Object lock = new Object();
		File src = new File("/home/draft/uni/poster/bioxes_poster.zip");
		final File src2 = new File("/tmp/bioxes_poster.zip.copy");
		final File dst = new File("/tmp");
		final int SPLIT_SIZE = 1024 * 1024;
		final SplitterThread st = new SplitterThread(src, dst, SPLIT_SIZE);
		final URN urn = new URN(src);
		st.addObserver(new Observer()
		{
			@Override
			public void update(Observable o, Object arg)
			{
				if (st.hasFinishedSplitting())
				{
					final MergerThread mt = new MergerThread(st.getSplitFiles(), src2, urn
							.getSize(), SPLIT_SIZE, false, false);
					mt.addObserver(new Observer()
					{
						@Override
						public void update(Observable o, Object arg)
						{
							if (mt.hasFinishedMerging())
							{
								System.err.println("yes");
								synchronized (lock)
								{
									lock.notify();
								}
							}
							else
								System.err.print("+");
						}
					});
					mt.merge();
				}
				else
					System.err.print("~");
			}
		});
		st.split();
		synchronized (lock)
		{
			lock.wait();
		}
		Assert.assertEquals(Utils.makeSHAHash(src), Utils.makeSHAHash(src2));
	}
}
